#include "vdongle.h"
// Interface-Unit zum Ansprechen von VDONGLE.386.
// Unter Windows95 wird  das VxD ggf. dynamisch ge- und entladen,
// ohne Zutun im Hauptprogramm

static int NullFunc(UINT,void*) {return 0;}
static int(*VDongleEntry)(UINT,void*)=NullFunc;
bool DriverUnloadAtExit;

//DWORD VXDLDR_Entry(UINT,UINT,char* =0);

static void(*OldExit)();
void (*ExitProc)();


const TCHAR stDosDevice[]=TEXT("\\\\.\\VDONGLE.386");

HANDLE hVDongle;
static SC_HANDLE hSCManager;

int NTFunc(UINT fn,void*lpInBuffer) {
/*Umsetzung INT2F -> DeviceIOControl*/
 DWORD inLen=0;
 switch (fn) {
  case 0x101: inLen=16; break;	/*sizeof(TAccessCounter)*/
  case 0x501:
  case 0x502:
  case 0x503: inLen=lstrlenA((char*)lpInBuffer)+1; break;	/*Terminator dazu*/
 }
 DWORD IOBuffer=0,BytesReturned;
 DeviceIoControl(hVDongle,MAKEWORD(40000,fn<<2|0x6000),lpInBuffer,inLen,
   fn==0x1FF || HIBYTE(fn)==6 ? lpInBuffer : &IOBuffer,
   fn==0x1FF ? 16 /*sizeof(TAccessCounter)*/ : HIBYTE(fn)==6 ? 8 /*sizeof(TFileStatistics)*/: 4,
   &BytesReturned,0);
 return IOBuffer;
}

void NT_Stop() {
 if (hVDongle && CloseHandle(hVDongle)) hVDongle=0;
 if (DriverUnloadAtExit) {
  SC_HANDLE h=OpenService(hSCManager,stDriver,SERVICE_STOP);
  if (h) {
   SERVICE_STATUS ss;
   ControlService(h,SERVICE_CONTROL_STOP,&ss);
   CloseServiceHandle(h);
  }
 }
 VDongleEntry=NullFunc;
}

void NewNTExit() {
 ExitProc=OldExit;
 NT_Stop();
 CloseServiceHandle(hSCManager);
}

bool GetVDongleEntry() {
/*Eintrittspunkt fr VDONGLE.386 holen*/
 _asm{	xor	di,di
	mov	es,di
	mov	bx,VDongle_Device_ID
	mov	ax,0x1684	/*Get Device API Entry Point*/
	int	0x2F
	mov	ax,es
	or	ax,ax
	jz	ex
	mov	word ptr [VDongleEntry],di
	mov	word ptr [VDongleEntry+2],ax
ex:
 }
 return !!VDongleEntry;
}

bool LoadNTDriver() {
 HANDLE h=CreateFile(stDosDevice,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
 if (h==INVALID_HANDLE_VALUE) h=0;
 hVDongle=h;
 if (h) VDongleEntry=NTFunc;
 return !!h;
}

bool NT_Start() {
 if (LoadNTDriver()) return true;
 SC_HANDLE h=OpenService(hSCManager,stDriver,SERVICE_START);
 if (!h) return false;
 StartService(h,0,0);
 DriverUnloadAtExit=true;
 CloseServiceHandle(h);
 return LoadNTDriver();
}

void vdongle_init() {	/*Initialisierung*/
 hSCManager=OpenSCManager(0,0,GENERIC_READ);
 NT_Start();
 ExitProc=NewNTExit;
}
